;----------------------------------------------------------------------------
;                       strings.inc                    2012-01-30 Agner Fog
;
; Include file for testing string instructions 
;
; The following macros can be defined on the command line or in include files:
; 
; instruct:     The name of a single instruction to test
; 
; repp:         Repeat prefix: rep, repe, or undefined
;
; count:        Repeat count (only if repeat prefix)
;
; misalign:     Alignment offset
;
; (c) Copyright 2012 by Agner Fog. GNU General Public License www.gnu.org/licenses
;-----------------------------------------------------------------------------
; Define any undefined macros

%ifndef instruct
   %define instruct  lodsb  ; default instruction 
%endif

%ifndef count
   %define count  100
%endif

%ifndef misalign
   %define misalign  0      ; default misalignment
%endif

%ifndef regsize              ; default: define registers as 256 bit
   %define regsize   32
%endif

;-----------------------------------------------------------------------------
;                 User data
;-----------------------------------------------------------------------------

%macro testdata 0
   times 100000  DD 0 
%endmacro


;##############################################################################
;#
;#                 Test code macro
;#
;##############################################################################

        
%macro testcode 0
   %ifdef  repp   ; repeat prefix used        
      mov ebx, count
      lea r8, [UserData+misalign]
      lea r9, [UserData+misalign+240h]
      xor eax, eax
      %rep 100
         mov rsi, r8
         mov rdi, r9
         mov ecx, ebx
         repp instruct
      %endrep 

   %else   ; no repeat prefix
      lea rsi, [UserData+misalign]
      lea rdi, [UserData+misalign+240h]
      %rep 100
         instruct
      %endrep 

   %endif
%endmacro


