#                       TESTP.MAKE                        2012-03-02 Agner Fog

# (c) Copyright 2000-2012 GNU General Public License www.gnu.org/licenses


# Makefile for TESTP package of test programs. See testp.txt for details.

testp.zip: PMCTest\PMCTest.zip DriverSrcWin\DriverSrcWin.zip DriverSrcLinux\DriverSrcLinux.zip \
vs2008\vs2008_project_files.zip vs2010\vs2010_project_files.zip \
instruction_scripts\instruction_scripts.zip test_scripts\test_scripts.zip \
old\old.zip \
testp.txt testp.make MakeTestp.bat
    wzzip $@ $?

PMCTest\PMCTest.zip: PMCTest\PMCTest.txt \
PMCTest\PMCTestA.cpp PMCTest\PMCTestB.cpp \
PMCTest\PMCTest.h PMCTest\PMCTestWin.h PMCTest\PMCTestLinux.h \
PMCTest\MSRDriver.h PMCTest\intrin1.h PMCTest\MSRdrvL.h \
PMCTest\PMCTestB32.asm PMCTest\PMCTestB64.asm \
PMCTest\PMCTestB32.nasm PMCTest\PMCTestB64.nasm \
PMCTest\TemplateB32.nasm PMCTest\TemplateB64.nasm \
PMCTest\PMCTestA32.obj PMCTest\PMCTestA64.obj \
PMCTest\a32.sh PMCTest\a64.sh PMCTest\c32.sh PMCTest\c64.sh \
PMCTest\uninstall.cpp PMCTest\uninstall.exe \
DriverSrcWin\MSRDriver32.sys DriverSrcWin\MSRDriver64.sys
    wzzip $@ $?

DriverSrcWin\DriverSrcWin.zip: DriverSrcWin\MSRDriver.cpp \
PMCTest\MSRDriver.h PMCTest\intrin1.h \
DriverSrcWin\MakeDriver32.bat DriverSrcWin\MakeDriver64.bat \
DriverSrcWin\MSRDriver32.sys DriverSrcWin\MSRDriver64.sys
    wzzip $@ $?
  
DriverSrcLinux\DriverSrcLinux.zip: DriverSrcLinux\DriverSrcLinux.txt \
DriverSrcLinux\MSRdrv.c PMCTest\MSRDriver.h PMCTest\MSRdrvL.h \
DriverSrcLinux\Makefile DriverSrcLinux\install.sh DriverSrcLinux\uninstall.sh
    wzzip $@ $?
    
vs2008\vs2008_project_files.zip: \
vs2008\a32.sln vs2008\a64.sln vs2008\c32.sln vs2008\c64.sln \
vs2008\a32.vcproj vs2008\a64.vcproj vs2008\c32.vcproj vs2008\c64.vcproj \
vs2008\a32.suo vs2008\a64.suo vs2008\c32.suo vs2008\c64.suo \
vs2008\m32.bat vs2008\m64.bat vs2008\n32.bat vs2008\n64.bat \
vs2008\y32.bat vs2008\y64.bat
    wzzip $@ $?

vs2010\vs2010_project_files.zip: \
vs2010\a32.sln vs2010\a64.sln vs2010\c32.sln vs2010\c64.sln \
vs2010\a32.vcxproj vs2010\a64.vcxproj vs2010\c32.vcxproj vs2010\c64.vcxproj \
vs2010\a32.suo vs2010\a64.suo vs2010\c32.suo vs2010\c64.suo
    wzzip $@ $?

test_scripts\test_scripts.zip: \
test_scripts\countertypes.inc test_scripts\daxpy.inc test_scripts\denormal.inc \
test_scripts\lt.inc test_scripts\memcpy.inc test_scripts\returnstack.inc \
test_scripts\taylor.inc test_scripts\xor.inc test_scripts\daxpy.sh2 \
test_scripts\denormal.sh2 test_scripts\memcpy.sh2 test_scripts\returnstack.sh2 \
test_scripts\taylor.sh2 test_scripts\xor.sh2 test_scripts\allsh2.sh
    wzzip $@ $?

instruction_scripts\instruction_scripts.zip: \
instruction_scripts\32bitinstr.inc instruction_scripts\convers.inc \
instruction_scripts\countertypes.inc instruction_scripts\div.inc \
instruction_scripts\fvecdiv.inc instruction_scripts\lt.inc \
instruction_scripts\miscellaneous.inc instruction_scripts\mul.inc \
instruction_scripts\nops.inc instruction_scripts\pushpop.inc \
instruction_scripts\shift.inc instruction_scripts\strings.inc \
instruction_scripts\x87.inc instruction_scripts\32bitinstr.sh1 \
instruction_scripts\amd.sh1 instruction_scripts\convers.sh1 \
instruction_scripts\div.sh1 instruction_scripts\fvec.sh1 \
instruction_scripts\int.sh1 instruction_scripts\ivec.sh1 \
instruction_scripts\miscellaneous.sh1 instruction_scripts\mul.sh1 \
instruction_scripts\nops.sh1 instruction_scripts\pushpop.sh1 \
instruction_scripts\shift.sh1 instruction_scripts\strings.sh1 \
instruction_scripts\x87.sh1 instruction_scripts\vars.sh \
instruction_scripts\allsh1.sh
    wzzip $@ $?

old\TSCUni.zip: old\TSCUni\TSCTest.cpp old\TSCUni\TSCUni.txt \
old\TSCUni\w32.dsw old\TSCUni\w32.dsp old\TSCUni\w32.opt \
old\TSCUni\MakeMS32.bat old\TSCUni\MakeMS64.bat old\TSCUni\MakeDM32.bat \
old\TSCUni\MakeI64.bat old\TSCUni\MakeBor32.bat \
../asmlib/asmlib.h ../asmlib/lib/alibomf32.lib ../asmlib/lib/alibcof32.lib ../asmlib/lib/alibcof64.lib \
old\TSCUni\lg32.sh old\TSCUni\lg64.sh old\TSCUni\li32.sh old\TSCUni\li64.sh
    wzzip $@ $?

old\TSCWin.zip: old\TSCWin\TSCTestA.cpp \
old\TSCWin\TSCTestB32.asm old\TSCWin\TSCTestB64.asm \
old\TSCWin\MakeTSCTest32.bat old\TSCWin\MakeTSCTest64.bat \
old\TSCWin\w32.dsw old\TSCWin\w32.dsp \
old\TSCWin\w64.vcproj old\TSCWin\w64.sln old\TSCWin\w64.suo \
old\TSCWin\TSCWin.txt
    wzzip $@ $?

old\PMCDOS.zip: old\PMCDOS\p1test.asm old\PMCDOS\p23test.asm old\PMCDOS\p4test.asm \
old\PMCDOS\64test.asm old\PMCDOS\AMDtest.asm old\PMCDOS\p4macros.asi old\PMCDOS\sse3.asi old\PMCDOS\sse3b.asi \
old\PMCDOS\t16.bat old\PMCDOS\t32.bat old\PMCDOS\t64.bat old\PMCDOS\m16.bat old\PMCDOS\m32.bat \
old\PMCDOS\link16.exe old\PMCDOS\tasm.exe old\PMCDOS\PMCDOS.txt
    wzzip $@ $?
  
old\old.zip: old\TSCUni.zip old\TSCWin.zip old\PMCDOS.zip
    wzzip $@ $?
